package com.felhr.examplestreams;

import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.ServiceConnection;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.support.annotation.RequiresApi;
import android.support.v7.app.AppCompatActivity;
import android.util.Base64;
import android.util.Log;
import android.view.View;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import java.io.IOException;
import java.lang.ref.WeakReference;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Set;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;


public class MainActivity extends AppCompatActivity {

    /*
     * Notifications from UsbService will be received here.
     */
    private final BroadcastReceiver mUsbReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            switch (intent.getAction()) {
                case UsbService.ACTION_USB_PERMISSION_GRANTED: // USB PERMISSION GRANTED
                    Toast.makeText(context, "USB Ready", Toast.LENGTH_SHORT).show();
                    break;
                case UsbService.ACTION_USB_PERMISSION_NOT_GRANTED: // USB PERMISSION NOT GRANTED
                    Toast.makeText(context, "USB Permission not granted", Toast.LENGTH_SHORT).show();
                    break;
                case UsbService.ACTION_NO_USB: // NO USB CONNECTED
                    Toast.makeText(context, "No USB connected", Toast.LENGTH_SHORT).show();
                    break;
                case UsbService.ACTION_USB_DISCONNECTED: // USB DISCONNECTED
                    Toast.makeText(context, "USB disconnected", Toast.LENGTH_SHORT).show();
                    break;
                case UsbService.ACTION_USB_NOT_SUPPORTED: // USB NOT SUPPORTED
                    Toast.makeText(context, "USB device not supported", Toast.LENGTH_SHORT).show();
                    break;
            }
        }
    };
    private UsbService usbService;
    private TextView display;
    private EditText editText;
    private CheckBox box9600, box38400;
    private MyHandler mHandler;
    private Object udpclient;
    public static Handler exHandler;
    private ArrayList<MyCache> cache = new ArrayList<MyCache>();
    private int radius=1000;
    private Bitmap curr_img=null;

    private final ServiceConnection usbConnection = new ServiceConnection() {
        @Override
        public void onServiceConnected(ComponentName arg0, IBinder arg1) {
            usbService = ((UsbService.UsbBinder) arg1).getService();
            usbService.setHandler(mHandler);
        }

        @Override
        public void onServiceDisconnected(ComponentName arg0) {
            usbService = null;
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {



        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
//        View img1=findViewById(R.id.imageView);
//        img1.setVisibility(View.INVISIBLE);
        ImageView imtest = findViewById(R.id.imageKlaus);

        exHandler=new Handler() {
            @Override
            public void handleMessage(Message msg) {
                super.handleMessage(msg);
                String msgString = (String)msg.obj;
                Log.d("Handler","Now in Handler");
                TextView txt44 = findViewById(R.id.instruction);

//                txt44.setText(null);
//                txt44.setText("Receive: " + msgString);
                //Testing
//                imtest.setVisibility(View.VISIBLE);
//                if(curr_img!=null)
//                    imtest.setImageBitmap(curr_img);

            }
        };

        mHandler = new MyHandler(this);
        new UDP_Client().execute();


    }

    @Override
    public void onResume() {
        super.onResume();
        setFilters();  // Start listening notifications from UsbService
        startService(UsbService.class, usbConnection, null); // Start UsbService(if it was not started before) and Bind it
    }

    @Override
    public void onPause() {
        super.onPause();
        unregisterReceiver(mUsbReceiver);
        unbindService(usbConnection);
    }

    private void startService(Class<?> service, ServiceConnection serviceConnection, Bundle extras) {
        if (!UsbService.SERVICE_CONNECTED) {
            Intent startService = new Intent(this, service);
            if (extras != null && !extras.isEmpty()) {
                Set<String> keys = extras.keySet();
                for (String key : keys) {
                    String extra = extras.getString(key);
                    startService.putExtra(key, extra);
                }
            }
            startService(startService);
        }
        Intent bindingIntent = new Intent(this, service);
        bindService(bindingIntent, serviceConnection, Context.BIND_AUTO_CREATE);
    }

    private void setFilters() {
        IntentFilter filter = new IntentFilter();
        filter.addAction(UsbService.ACTION_USB_PERMISSION_GRANTED);
        filter.addAction(UsbService.ACTION_NO_USB);
        filter.addAction(UsbService.ACTION_USB_DISCONNECTED);
        filter.addAction(UsbService.ACTION_USB_NOT_SUPPORTED);
        filter.addAction(UsbService.ACTION_USB_PERMISSION_NOT_GRANTED);
        registerReceiver(mUsbReceiver, filter);
    }


    public class UDP_Client extends AsyncTask {
        DatagramSocket socket = null;

        @Override
        protected Object doInBackground(Object[] objects) {
            byte[] buf = new byte[65000];

            InetAddress address= null;
            try {
                address = InetAddress.getByName("255.255.255.255");
            } catch (UnknownHostException e) {
                e.printStackTrace();
            }

            while(true){
                try {
                    socket = new DatagramSocket(37020,address);
                } catch (SocketException e) {
                    e.printStackTrace();
                }
                DatagramPacket packet = new DatagramPacket(buf, buf.length);
                try {
                    socket.receive(packet);
                } catch (IOException e) {

                }
//                5;0;200,300;text;img
//                HashMap<String, byte[]> received_item = new HashMap<>();
//                received_item = (HashMap) packet.getData();
                byte[] rxbyte = packet.getData();
                String received = new String(packet.getData(), 0, packet.getLength());

                String[] loc_text = received.split(";");
                String[] loc = loc_text[2].split(",");
                int x = Integer.parseInt(loc[0]);
                int y = Integer.parseInt(loc[1]);
                String text = loc_text[3];
                int total_num = Integer.parseInt(loc_text[0]);
                int index = Integer.parseInt(loc_text[1]);
//                byte[] img_bytes = loc_text[4].getBytes();
                byte[] img_bytes = Base64.decode(loc_text[4], Base64.DEFAULT);
                Bitmap bitmap = BitmapFactory.decodeByteArray(img_bytes , 0, img_bytes.length);
//                curr_img = bitmap;
//                Drawable d = Drawable.createFromStream(new ByteArrayInputStream(img_bytes), null);


                if(total_num>cache.size())
                {
                    int curr_cache_size = cache.size();
//                    cache = new ArrayList<>();
                    for(int i=0;i<total_num-curr_cache_size;i++)
                    {
                        MyCache temp = new MyCache(0, 0, "", null);
                        cache.add(temp);
                    }
                }
                MyCache new_entry = new MyCache(x,y,text,bitmap);
                cache.set(index,new_entry);

//                for(MyCache j:cache)
//                {
                MainActivity.exHandler.sendMessage(MainActivity.exHandler.obtainMessage(1,new_entry.text));
//                }


//                MainActivity.exHandler.sendMessage(MainActivity.exHandler.obtainMessage(1,received));
            }


//            return null;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        protected void onPostExecute(Void result)
        {
            socket.close();
            super.onPostExecute(result);
        }
    }


    class MyCache {
        public int loc_x;
        public int loc_y;
        public String text;
        //    public Drawable d;
        public Bitmap bm;

        public MyCache(int i, int i1, String s, Bitmap bm) {
            this.loc_x = i;
            this.loc_y = i1;
            this.text = s;
            this.bm=bm;
        }

    }

    /*
     * This handler will be passed to UsbService. Data received from serial port is displayed through this handler
     */
    class MyHandler extends Handler {
        private final WeakReference<MainActivity> mActivity;

        public MyHandler(MainActivity activity) {
            mActivity = new WeakReference<>(activity);
        }

        int lineNum = 0;//skip the first line
        String line = "";
        String newline = System.getProperty("line.separator");
        //
        // final LinearLayout drawingExampleLayout = (LinearLayout)findViewById(R.id.exampleLinearLayout);
        Context context = getApplicationContext();
        int prevx = 0;
        int prevy = 0;
        ImageView img1=findViewById(R.id.imageStarry);
        TextView txt1=findViewById(R.id.textStarry);
        ImageView img2=findViewById(R.id.imageBoring);
        TextView txt2=findViewById(R.id.textBoring);
        ImageView img3=findViewById(R.id.imageKlaus);
        TextView txt3=findViewById(R.id.textKlaus);
        TextView txt=findViewById(R.id.text);
        TextView txt4=findViewById(R.id.instruction);
        int invisible_flag=1;
        //        int repeat1=0;
//        int repeat2=0;
//        int repeat3=0;
        @RequiresApi(api = Build.VERSION_CODES.O)
        @Override
        public void handleMessage(Message msg){

            switch (msg.what) {
//                case UsbService.MESSAGE_FROM_SERIAL_PORT:
//                    String data = (String) msg.obj;
//                    mActivity.get().display.append("data" + data);
//                    break;
                case UsbService.CTS_CHANGE:
                    Toast.makeText(mActivity.get(), "CTS_CHANGE", Toast.LENGTH_LONG).show();
                    break;
                case UsbService.DSR_CHANGE:
                    Toast.makeText(mActivity.get(), "DSR_CHANGE", Toast.LENGTH_LONG).show();
                    break;
                case UsbService.SYNC_READ:

                    String buffer = (String) msg.obj;//HERE IS THE ONE LINE MESSAGE FOR REAL TIME INPUT
                    String newBuffer = buffer.replace(" ", "@");
                    line = line.concat(newBuffer);//concatenate each character to a string



                    if (line.contains(newline)) {
                        if (lineNum != 0) {
                            lineNum++;
                            //mActivity.get().display.append("Line: " + line);
                            ExecutorService executor = Executors.newSingleThreadExecutor();

                            Callable callable =
                                    new sendGetClass()
                                            .setLine(line);

                            Future<String> future = (Future<String>) executor.submit(callable);
                            try {
                                if(future.get() !="") {
//                                    mActivity.get().display.append("tag location: " + future.get());
//                                    drawingExampleLayout.removeAllViews();
//                                    txt.setText("coordinates: ["+future.get());
                                    String[] coors = future.get().split(",");
                                    String xcor = coors[0].substring(1);
                                    String ycor = coors[1].substring(0,coors[1].length()-1);
//                                    mActivity.get().display.append("x: " + Integer.parseInt(xcor));
//                                    mActivity.get().display.append("y: " + Integer.parseInt(ycor));
//                                    if(Integer.parseInt(xcor)>=0 && Integer.parseInt(xcor)<=3600 && Integer.parseInt(ycor)>=0 && Integer.parseInt(ycor)<=3100) {
                                    prevx = Integer.parseInt(xcor);
                                    prevy = Integer.parseInt(ycor);
                                    txt.setText("coordinates: ["+prevx/1000+","+prevy/1000+"](m)");
                                    //     myCanvas mycanvas = new myCanvas(context, Integer.parseInt(xcor), Integer.parseInt(ycor));
                                    // drawingExampleLayout.addView(mycanvas);


                                    invisible_flag++;
                                    for(int i=0;i<cache.size();i++)
                                    {
                                        MyCache curr_art = cache.get(i);

                                        if (Integer.parseInt(xcor) > curr_art.loc_x-radius && Integer.parseInt(xcor) < curr_art.loc_x+radius) {
                                            if (Integer.parseInt(ycor) > curr_art.loc_y-radius && Integer.parseInt(ycor) < curr_art.loc_y+radius) {
                                                txt4.setVisibility(View.INVISIBLE);
                                                img3.setVisibility(View.VISIBLE);
//                                                img3.setImageDrawable(curr_art.d);
                                                img3.setImageBitmap(curr_art.bm);
                                                txt3.setVisibility(View.VISIBLE);
                                                txt3.setText(curr_art.text);
//                                                img3.setVisibility(View.INVISIBLE);
//                                                txt3.setVisibility(View.INVISIBLE);
//                                                img1.setVisibility(View.VISIBLE);
//                                                txt1.setVisibility(View.VISIBLE);
                                                invisible_flag=0;
                                            }
                                        }
                                    }

                                    if(invisible_flag>15)
                                    {
                                        img3.setVisibility(View.INVISIBLE);
                                        txt3.setVisibility(View.INVISIBLE);
                                        txt4.setVisibility(View.VISIBLE);
                                    }
                                    /*
                                    // OLD LOCATION CHECKING CODE
                                    invisible_flag++;
                                    if (Integer.parseInt(xcor) > 128940-2000 && Integer.parseInt(xcor) < 128940+2000) {
                                        if (Integer.parseInt(ycor) > 83430-2000 && Integer.parseInt(ycor) < 83430+2000) {
                                            txt4.setVisibility(View.INVISIBLE);
                                            img2.setVisibility(View.INVISIBLE);
                                            txt2.setVisibility(View.INVISIBLE);
                                            img3.setVisibility(View.INVISIBLE);
                                            txt3.setVisibility(View.INVISIBLE);
                                            img1.setVisibility(View.VISIBLE);
                                            txt1.setVisibility(View.VISIBLE);
                                            invisible_flag=0;
//                                            repeat1++;
                                        }
                                    }
                                    if (Integer.parseInt(xcor) > 127010 && Integer.parseInt(xcor) < 131010) {
                                        if (Integer.parseInt(ycor) > 75970-2000 && Integer.parseInt(ycor) < 75970+2000) {
                                            txt4.setVisibility(View.INVISIBLE);
                                            img1.setVisibility(View.INVISIBLE);
                                            txt1.setVisibility(View.INVISIBLE);
                                            img3.setVisibility(View.INVISIBLE);
                                            txt3.setVisibility(View.INVISIBLE);
                                            img2.setVisibility(View.VISIBLE);
                                            txt2.setVisibility(View.VISIBLE);
//                                            repeat2++;
                                            invisible_flag=0;
                                        }
                                    }
                                    if (Integer.parseInt(xcor) > 110030 && Integer.parseInt(xcor) < 116030) {
                                        if (Integer.parseInt(ycor) > 84150 && Integer.parseInt(ycor) < 90150) {
                                            txt4.setVisibility(View.INVISIBLE);
                                            img1.setVisibility(View.INVISIBLE);
                                            txt1.setVisibility(View.INVISIBLE);
                                            img2.setVisibility(View.INVISIBLE);
                                            txt2.setVisibility(View.INVISIBLE);
                                            img3.setVisibility(View.VISIBLE);
                                            txt3.setVisibility(View.VISIBLE);
//                                            repeat3++;
                                            invisible_flag=0;
                                        }
                                    }

                                    if(invisible_flag>15)
                                    {
                                        img1.setVisibility(View.INVISIBLE);
                                        txt1.setVisibility(View.INVISIBLE);
                                        img2.setVisibility(View.INVISIBLE);
                                        txt2.setVisibility(View.INVISIBLE);
                                        img3.setVisibility(View.INVISIBLE);
                                        txt3.setVisibility(View.INVISIBLE);
                                        txt4.setVisibility(View.VISIBLE);
                                    }

                                     */

//                                    if (Integer.parseInt(xcor) > -300 && Integer.parseInt(xcor) < 300) {
//                                        if (Integer.parseInt(ycor) > -300 && Integer.parseInt(ycor) < 300) {
//                                            //                                            mActivity.get().display.append("at 0");
//                                            Snackbar snackbar = Snackbar.make(findViewById(R.id.myCoordinatorLayout), R.string.anchor0,
//                                                    Snackbar.LENGTH_SHORT);
//                                                Snackbar.SnackbarLayout layout = (Snackbar.SnackbarLayout) snackbar.getView();
//// Hide the text
//                                                TextView textView = (TextView) layout.findViewById(android.support.design.R.id.snackbar_text);
////                                                textView.setVisibility(View.resolveSize(100,100));
//                                                textView.getExtendedPaddingBottom();
//                                                textView.setHeight(250);
//                                                textView.setTextSize(20);
//                                                snackbar.show();
//                                        }
//                                        if (Integer.parseInt(ycor) > 2800 && Integer.parseInt(ycor) < 3400) {
//                                            //                                            mActivity.get().display.append("at 3");
//                                            Snackbar snackbar = Snackbar.make(findViewById(R.id.myCoordinatorLayout), R.string.anchor3,
//                                                    Snackbar.LENGTH_SHORT);
//                                            Snackbar.SnackbarLayout layout = (Snackbar.SnackbarLayout) snackbar.getView();
//// Hide the text
//                                            TextView textView = (TextView) layout.findViewById(android.support.design.R.id.snackbar_text);
////                                                textView.setVisibility(View.resolveSize(100,100));
//                                            textView.getExtendedPaddingBottom();
//                                            textView.setHeight(250);
//                                            textView.setTextSize(20);
//                                            snackbar.show();
//
//
//                                        }
//                                    }

//                                    if (Integer.parseInt(xcor) > 3300 && Integer.parseInt(xcor) < 3900) {
//                                        if (Integer.parseInt(ycor) > -300 && Integer.parseInt(ycor) < 300) {
//                                            //                                            mActivity.get().display.append("at 0");
//                                            Snackbar snackbar = Snackbar.make(findViewById(R.id.myCoordinatorLayout), R.string.anchor1,
//                                                    Snackbar.LENGTH_SHORT);
//                                            Snackbar.SnackbarLayout layout = (Snackbar.SnackbarLayout) snackbar.getView();
//// Hide the text
//                                            TextView textView = (TextView) layout.findViewById(android.support.design.R.id.snackbar_text);
////                                                textView.setVisibility(View.resolveSize(100,100));
//                                            textView.getExtendedPaddingBottom();
//                                            textView.setHeight(250);
//                                            textView.setTextSize(20);
//                                            snackbar.show();
//                                        }
//                                        if (Integer.parseInt(ycor) > 2800 && Integer.parseInt(ycor) < 3400) {
//                                            //                                            mActivity.get().display.append("at 3");
//                                            Snackbar snackbar = Snackbar.make(findViewById(R.id.myCoordinatorLayout), R.string.anchor2,
//                                                    Snackbar.LENGTH_SHORT);
//                                            Snackbar.SnackbarLayout layout = (Snackbar.SnackbarLayout) snackbar.getView();
//// Hide the text
//                                            TextView textView = (TextView) layout.findViewById(android.support.design.R.id.snackbar_text);
////                                                textView.setVisibility(View.resolveSize(100,100));
//                                            textView.getExtendedPaddingBottom();
//                                            textView.setHeight(250);
//                                            textView.setTextSize(20);
//                                            snackbar.show();
//
//
//                                        }
//                                    }

//                                    if (Integer.parseInt(xcor) > 1300 && Integer.parseInt(xcor) < 2100) {
//                                        if (Integer.parseInt(ycor) > 1300 && Integer.parseInt(ycor) < 1700) {
//                                            //                                            mActivity.get().display.append("at 0");
//                                            Snackbar snackbar = Snackbar.make(findViewById(R.id.myCoordinatorLayout), R.string.center,
//                                                    Snackbar.LENGTH_SHORT);
//                                            Snackbar.SnackbarLayout layout = (Snackbar.SnackbarLayout) snackbar.getView();
//// Hide the text
//                                            TextView textView = (TextView) layout.findViewById(android.support.design.R.id.snackbar_text);
////                                                textView.setVisibility(View.resolveSize(100,100));
//                                            textView.getExtendedPaddingBottom();
//                                            textView.setHeight(250);
//                                            textView.setTextSize(20);
//                                            snackbar.show();
//                                        }
//                                    }
//                                }
//                                    else{
//                                        myCanvas mycanvas = new myCanvas(context, prevx, prevy);
//                                        drawingExampleLayout.addView(mycanvas);
//                                    }
//                                    else{
//                                        mActivity.get().display.append("");
//                                    }
                                }
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            } catch (ExecutionException e) {
                                e.printStackTrace();
                            }
                            line = "";

                        } else {
                            lineNum++;
                            line = "";
                        }
                    }
                    //}
                    break;

            }
        }
    }

}
