import socket
import time
import json

server = socket.socket(socket.AF_INET, socket.SOCK_DGRAM, socket.IPPROTO_UDP)

# Enable port reusage so we will be able to run multiple clients and servers on single (host, port). 
# Do not use socket.SO_REUSEADDR except you using linux(kernel<3.9): goto https://stackoverflow.com/questions/14388706/how-do-so-reuseaddr-and-so-reuseport-differ for more information.
# For linux hosts all sockets that want to share the same address and port combination must belong to processes that share the same effective user ID!
# So, on linux(kernel>=3.9) you have to run multiple servers and clients under one user to share the same (host, port).
# Thanks to @stevenreddie
server.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEPORT, 1)

# Enable broadcasting mode
server.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)

# Set a timeout so the socket does not block
# indefinitely when trying to receive data.
server.settimeout(0.2)
#message = b"your very important message"
#message={"100,100":"piece1","200,200":"piece2"}
#msg=json.dumps(message)
#msg=json.dumps(message, ensure_ascii=False).encode('gbk')
msg1=b"100,100:piece1"
msg2=b"200,200:piece2"
msg3=b"300,300:piece3"
msg4=b"400,400:piece4"
#print("type: ",type(msg))
while True:
    for i in range(4):
        if i==0:
            server.sendto(msg1, ('<broadcast>', 37020))
            print("message sent!")
            time.sleep(1)
        if i==1:
            server.sendto(msg2, ('<broadcast>', 37020))
            print("message sent!")
            time.sleep(1)
        if i==2:
            server.sendto(msg3, ('<broadcast>', 37020))
            print("message sent!")
            time.sleep(1)
        if i==3:
            server.sendto(msg4, ('<broadcast>', 37020))
            print("message sent!")
            time.sleep(1)
